---
title: escape()
slug: Web/JavaScript/Reference/Global_Objects/escape
tags:
  - Deprecated
  - JavaScript
  - Method
---
<div>{{jsSidebar("Objects")}}</div>

<div class="warning"><strong>Warning:</strong> Although <code>escape()</code> is not strictly deprecated (as in "removed from the Web standards"), it is defined in <a href="https://www.ecma-international.org/ecma-262/9.0/index.html#sec-additional-ecmascript-features-for-web-browsers">Annex B</a> of the ECMA-262 standard, whose introduction states:

<blockquote>… All of the language features and behaviours specified in this annex have one or more undesirable characteristics and in the absence of legacy usage would be removed from this specification. …<br>
… Programmers should not use or assume the existence of these features and behaviours when writing new ECMAScript code. …</blockquote>
</div>

<p><span class="seoSummary">The <code><strong>escape()</strong></code> function computes a new string in which certain characters have been replaced by a hexadecimal escape sequence.</span></p>

<div class="notecard note">
<p><strong>Note:</strong> This function was used mostly for URL queries (the part of a URL following <code>?</code>)—<em>not</em> for escaping ordinary String literals, which use the format "<code>\x<var>HH</var></code>". (<code><var>HH</var></code> are two hexadecimal digits, and the form <code>\x<var>HH</var>\x<var>HH</var></code> is used for higher-plane Unicode characters.)</p>

<p>Escaped characters in String literals can be expanded by replacing the <code>\x</code> with <code>%</code>, then using the <code>decodeURIComponent()</code> function.</p>
</div>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox">escape(<var>str</var>)</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt><code><var>str</var></code></dt>
 <dd>A string to be encoded.</dd>
</dl>

<h3 id="Return_value">Return value</h3>

<p>A new string in which certain characters have been escaped.</p>

<h2 id="Description">Description</h2>

<p>The <code>escape</code> function is a property of the <em>global object</em>. Special characters are encoded with the exception of: <code>@*_+-./</code></p>

<p>The hexadecimal form for characters, whose code unit value is <code>0xFF</code> or less, is a two-digit escape sequence: <code>%<var>xx</var></code>. For characters with a greater code unit, the four-digit format <code>%<strong>u</strong><var>xxxx</var></code> is used.</p>

<h2 id="Examples">Examples</h2>

<h3 id="Using_escape">Using escape</h3>

<pre class="brush: js">escape('abc123');     // "abc123"
escape('äöü');        // "%E4%F6%FC"
escape('ć');          // "%u0107"

// special characters
escape('@*_+-./');    // "@*_+-./"</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('ESDraft', '#sec-escape-string', 'escape')}}</td>
  </tr>
 </tbody>
</table>

<div class="hidden">Please do not add polyfills to reference pages. For more information, see <a href="https://discourse.mozilla.org/t/mdn-rfc-001-mdn-wiki-pages-shouldnt-be-a-distributor-of-polyfills/24500">https://discourse.mozilla.org/t/mdn-rfc-001-mdn-wiki-pages-shouldnt-be-a-distributor-of-polyfills/24500</a></div>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("javascript.builtins.escape")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{jsxref("encodeURI")}}</li>
 <li>{{jsxref("encodeURIComponent")}}</li>
 <li>{{jsxref("unescape")}}</li>
</ul>
